#include <lpc214x.h>

void delay (void)
{
	for (int i=0; i<50; i++)
	{
		for (int j=0;j<50;j++)
		{
		}
	}
}

void send_cmd (unsigned char cmd)
      {
         IOCLR1|=(1<<16);     // clearing P1.16 so RS=0 because we are sending command here
         IOCLR1|=(1<<17);     //  clearing P1.17 so R/W=0, therefore write operation
         IOSET1|=cmd<<19;     //  our data pins are connected from P1.19 to P1.22
         IOSET1|=(1<<18);    //   Set the enable pin
         delay ();     // wait a little, maybe 5 ms
         IOCLR1|=(1<<18);    // clear the Enable pin
         delay();     // wait a little
         IOCLR1|=cmd<<19;    // clear the data pins for next data or command
			}
			
 void decode_cmd (unsigned char cmd)
        {
           unsigned char cmd_low, cmd_high;    // defining cmd_low for lower 4 bits and cmd_high for higher 4 bits
           cmd_high = (cmd>>4)&0x0f;    // lower bits will become 0's and we will get only upper 4 bits
           cmd_low = (cmd)&0x0f;    // shift the lower bits to the upper bits position          
           send_cmd (cmd_high);     // send upper 4 bits to lcd
           send_cmd (cmd_low);     //  send lower 4 bits to lcd          
        }
				
  void send_data (unsigned char data)
      {
         IOSET1|=(1<<16);     // setting P1.16 so RS=1 because we are sending data here
         IOCLR1|=(1<<17);     //  clearing P1.17 so R/W=0, therefore write operation
         IOSET1|=data<<19;     //  our data pins are connected from P1.19 to P1.22
         IOSET1|=(1<<18);    //   Set the enable pin
        delay ();     // wait a little, maybe 5 ms
        IOCLR1|=(1<<18);    // clear the Enable pin
        delay();     // wait a little
        IOCLR1|=data<<19;    // clear the data pins for next data or command
      }

 void decode_data (unsigned char data)
        {
           unsigned char data_low, data_high;    // defining data_low for lower 4 bits and data_high for higher 4 bits
           data_high = (data>>4)&0x0f;    // lower bits will become 0's and we will get only upper 4 bits
           data_low = (data)&0x0f;    // shift the lower bits to the upper bits position          
           send_data (data_high);     // send upper 4 bits to lcd
           send_data (data_low);     //  send lower 4 bits to lcd          
        }

void send_string (char *data)
       {
           while (*data)    // while loop runs until last character of the string is reached
             {
                decode_data (*data++);    // send data to lcd and increment pointer to string
              }
        }
			 
				
void lcd_init (void)
      {
        decode_cmd (0x02);    // cmd to initialize in 4 bit mode
        decode_cmd (0x28);   // cmd to initialize in 4 bit mode
        decode_cmd (0x0c);   // display off cursor on
        decode_cmd (0x80);  // set the display in first row 0th column
      }

int main ()
{
	PINSEL2 = 0;    // setting pinsel register for gpio function
	IODIR1 = 0x00ff0000;    // setting pins 16 to 23 as output
	char hello[] = "HELLO WORLD";     // string we want to display on lcd
	lcd_init ();     // initialize the lcd
	send_string (hello);
	decode_cmd (0xc0);    // set cursor to 2nd row 0th column
	send_string ("test success");
}
	